/*
 MOUSE.H

 License CC0 PUBLIC DOMAIN

 To the extent possible under law, Mark J. Olesen has waived all copyright
 and related or neighboring rights to FDOSTUI Library. This work is published
 from: United States.
*/
#ifndef __mouse_h__

struct mouse_event 
{
    int 				m_btn_state;
    int 				m_curs_col;
    int 				m_curs_row;
};

#ifdef __cplusplus
extern "C" {
#endif

extern int mouse_initialized; 

extern int mouse_get_event(struct mouse_event far* o_event);

extern int mouse_init();

extern int mouse_deinit();

extern void mouse_hide();
#pragma aux mouse_hide= \
    "mov ax, [mouse_initialized]" \
    "or ax, ax" \
    "jz mhnomouse" \
    "mov ax, 02h" \
    "int 33h" \
    "mhnomouse:" \
    modify [ AX ];

extern void mouse_show();
#pragma aux mouse_show= \
    "mov ax, [mouse_initialized]" \
    "or ax, ax" \
    "jz msnomouse" \
    "mov ax, 01h" \
    "int 33h" \
    "msnomouse:" \
    modify [ AX ];

#ifdef __cplusplus
}
#endif

#define __mouse_h__
#endif
