/*
 SKIN.H

 License CC0 PUBLIC DOMAIN

 To the extent possible under law, Mark J. Olesen has waived all copyright 
 and related or neighboring rights to FDOSTUI Library. This work is published 
 from: United States.
*/
#ifndef __skin_h__

#include "screen.h"

struct skin_frame
{
    unsigned char                       m_hline;
    unsigned char                       m_vline;
    unsigned char                       m_top_left;
    unsigned char                       m_top_right;
    unsigned char                       m_bottom_left;
    unsigned char                       m_bottom_right;
    unsigned char                       m_middle_left;
    unsigned char                       m_middle_right;
};

struct skin_buttons
{
    unsigned char                       m_system;
    unsigned char                       m_close;
    unsigned char                       m_maximize;
    unsigned char                       m_minimize;
    unsigned char                       m_resize;
    unsigned char                       m_up;
    unsigned char                       m_down;
    unsigned char                       m_left;
    unsigned char                       m_right;
    unsigned char                       m_checked;
    unsigned char                       m_submenu;
    unsigned char                       m_thumb;
};

struct skin_window
{
    unsigned char                       m_fillc;
    enum foreground                     m_fcolor;
    enum background                     m_bcolor;
    enum foreground                     m_text_fcolor;
    enum background                     m_text_bcolor;
};

struct skin_menu
{
    struct skin_window                  m_window;
    enum foreground                     m_selected_fcolor;
    enum background                     m_selected_bcolor;
    enum foreground                     m_disabled_fcolor;
    enum background                     m_disabled_bcolor;
    enum foreground                     m_hotkey_fcolor;
    enum background                     m_hotkey_bcolor;
};

struct skin_button
{
    enum foreground                     m_fcolor;
    enum background                     m_bcolor;
    enum foreground                     m_focused;
    enum background                     m_shadow;
};

struct skin_label
{
    enum foreground                     m_fcolor;
    enum background                     m_bcolor;
};

struct skin_slider
{
    unsigned char                       m_fillc;
    enum foreground                     m_fcolor;
    enum background                     m_bcolor;
};

struct skin_listbox
{
    enum foreground                     m_fcolor;
    enum background                     m_bcolor;
    enum foreground                     m_highlight_fcolor;
    enum background                     m_highlight_bcolor;
    enum foreground                     m_selected_fcolor;
    enum background                     m_selected_bcolor;
};

#ifdef __cplusplus
extern "C" {
#endif

extern struct skin_buttons              _skin_buttons;
extern struct skin_frame                _skin_frame_single;
extern struct skin_window               _skin_window;
extern struct skin_menu                 _skin_menu;
extern struct skin_label                _skin_label;
extern struct skin_button               _skin_button;
extern struct skin_slider               _skin_slider;
extern struct skin_listbox              _skin_listbox;

#ifdef __cplusplus
}
#endif

#define __skin_h__
#endif
