/*
 BLOCK.C

 License CC0 PUBLIC DOMAIN

 To the extent possible under law, Mark J. Olesen has waived all copyright 
 and related or neighboring rights to FDOSTUI Library. This work is published 
 from: United States.
*/
#include "block.h"
#include "screen.h"
#include <malloc.h>
#include <stddef.h>

extern short int far*
block_read(
    struct box const*const              i_box)
{
    size_t                              l_size;
    short int far*                      l_block;
    short int far*                      l_next;
    int                                 l_pos_y;
    unsigned int                        l_row;

    l_size= (*i_box).m_len_x * (*i_box).m_len_y * 2;
    l_block= (short int far*)_fmalloc(l_size);
    l_next= l_block;

    for (l_row= 0; (*i_box).m_len_y > l_row; l_row++)
    {
        l_pos_y= (*i_box).m_pos_y + l_row;

        if (_video_rows <= l_pos_y)
        {
            break;
        }

        l_next= screen_read(
            l_next,
            (*i_box).m_len_x,
            (*i_box).m_pos_x,
            l_pos_y);
    }

    return l_block;
}

extern void
block_write(
    short int const far*                i_block,
    struct box const*const              i_box)
{
    short int const far*                l_next;
    int                                 l_pos_y;
    unsigned int                        l_row;

    l_next= i_block;

    for (l_row= 0; (*i_box).m_len_y > l_row; l_row++)
    {
        l_pos_y= (*i_box).m_pos_y + l_row;

        if (_video_rows <= l_pos_y)
        {
            break;
        }

        l_next= screen_write(
            (*i_box).m_pos_x,
            l_pos_y,
            l_next,
            (*i_box).m_len_x);
    }

    return;
}
